<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:xs="http://www.w3.org/2001/XMLSchema"
	xmlns:my="irgendeine_gueltige_URI"
	exclude-result-prefixes="#all"
	version="2.0">
	
	<xsl:param name="phrasenlaenge" as="xs:integer">7</xsl:param><!-- für my:render: Worte, sollte ein ungerader Wert sein -->
	
	<xsl:function name="my:ids" as="xs:string*">
		<xsl:param name="idref-string" as="xs:string?"/>
		<xsl:sequence select="for $i in tokenize($idref-string, '[ ]')[normalize-space(.)] return translate($i, '#', '')"/>
	</xsl:function>
	
	
	<xsl:function name="my:render" as="xs:string?">
		<xsl:param name="text" as="text()"/>
		<xsl:param name="wortanfang" as="xs:string"/>
		
		<!-- Vorbereitung -->
		<xsl:variable name="halbe-phrasenlaenge" as="xs:integer" select="xs:integer(floor($phrasenlaenge div 2) )"/>
		<xsl:variable name="worte" as="xs:string+" select="tokenize($text, ' ')"/>
		
		<!-- Ergebnisse erzeugen und Sammeln -->
		<xsl:variable name="teilergebnis-strings" as="xs:string*">
			<xsl:for-each select="$worte">
				<!-- es interessieren ja nur die fehlerhaften Stellen -->
				<xsl:if test="starts-with(., $wortanfang)">
					<xsl:variable name="aktuelle-wort-position" as="xs:integer" select="position()"/>
					<xsl:variable name="ein-paar-vorhergehende-worte" as="xs:string*" select="$worte[(position() gt $aktuelle-wort-position - $phrasenlaenge ) and (position() lt $aktuelle-wort-position)]"/>
					<xsl:variable name="ein-paar-folgende-worte" as="xs:string*" select="$worte[(position() gt $aktuelle-wort-position) and (position() lt $aktuelle-wort-position + $phrasenlaenge)]"/>
					<xsl:variable name="anzahl-vorhergehender-worte" as="xs:integer" select="count($ein-paar-vorhergehende-worte)"/>
					<xsl:variable name="anzahl-folgender-worte" as="xs:integer" select="count($ein-paar-folgende-worte)"/>
					<xsl:variable name="anzahl-fehlender-vorhergehender-worte" as="xs:integer" select="$halbe-phrasenlaenge - $anzahl-vorhergehender-worte"/>
					<xsl:variable name="anzahl-fehlender-vorhergehender-worte-positiv" as="xs:integer" select="if ($anzahl-fehlender-vorhergehender-worte gt 0) then $anzahl-fehlender-vorhergehender-worte else 0"/>
					<xsl:variable name="anzahl-fehlender-folgender-worte" as="xs:integer" select="$halbe-phrasenlaenge - $anzahl-folgender-worte"/>
					<xsl:variable name="anzahl-fehlender-folgender-worte-positiv" as="xs:integer" select="if ($anzahl-fehlender-folgender-worte gt 0) then $anzahl-fehlender-folgender-worte else 0"/>
					<xsl:sequence select="
										string-join((
											$ein-paar-vorhergehende-worte[position() gt last() - $halbe-phrasenlaenge - $anzahl-fehlender-folgender-worte-positiv],
											my:decorate-word(.),
											$ein-paar-folgende-worte[position() le $halbe-phrasenlaenge + $anzahl-fehlender-vorhergehender-worte-positiv]
										
										), ' ')"/>
				</xsl:if>
				
			</xsl:for-each>
		</xsl:variable>
		
		<!-- mehrere Teilergenbisse (Fundstellen je Text) mit »///« zusammenfügen -->
		<xsl:sequence select="string-join($teilergebnis-strings, '///')"/>
		
	</xsl:function>
	
	<xsl:function name="my:decorate-word" as="xs:string?">
		<xsl:param name="wort" as="xs:string?"/>
		<xsl:sequence select="concat('***', $wort, '***')"/>
	</xsl:function>
	
	
</xsl:stylesheet>